import cv2
import os
import numpy as np

def get_images_and_labels(path):
    image_paths = [os.path.join(path, f) for f in os.listdir(path) if not f.startswith('B')]
    image_pathsSon = [os.path.join(path, f) for f in os.listdir(path) if not f.startswith('F')]

    images = []
    labels = []

    for image_path in image_paths:
        image_cv = cv2.imread(image_path)
        image_cv = cv2.cvtColor(image_cv, cv2.COLOR_BGR2GRAY)
        image_cv = cv2.resize(image_cv, (800, 600))

        image_np = np.array(image_cv, 'uint8')

        nbr = int(os.path.split(image_path)[1].split(".")[0].replace("F_", ""))
        faces = faceCascade.detectMultiScale(image_np)

        for (x, y, w, h) in faces:
            if h > 150 and w > 150:
                image_Face = cv2.resize(image_np[y: y + h, x: x + w], (400, 400))
                image = np.array(image_Face, 'uint8')
                images.append(image)
                labels.append(nbr)
                cv2.imshow("Adding faces to traning set...", image)
                cv2.waitKey(1)

    for image_path in image_pathsSon:
        image_cv = cv2.imread(image_path)
        image_cv = cv2.cvtColor(image_cv, cv2.COLOR_BGR2GRAY)
        image_cv = cv2.resize(image_cv, (800,600))

        image_np = np.array(image_cv, 'uint8')

        nbr = int(os.path.split(image_path)[1].split(".")[0].replace("B_", ""))
        faces = faceCascade.detectMultiScale(image_np)

        for (x, y, w, h) in faces:
            if h > 150 and w > 150:
                image_Face = cv2.resize(image_np[y: y + h, x: x + w], (400, 400))
                image = np.array(image_Face, 'uint8')
                images.append(image)
                labels.append(nbr)
                cv2.imshow("Adding faces to traning set...", image)
                cv2.waitKey(1)

    return images, labels

def getPersonByProportion(image):
    face1 = 255
    face2 = 0
    gray = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)

    faces = faceCascade.detectMultiScale(
        gray,
        scaleFactor=1.1,
        minNeighbors=5,
        flags = cv2.CASCADE_SCALE_IMAGE,
        minSize=(64, 64)
    )

    print "Found {0} faces!".format(len(faces))
    x1 = 0.0
    x2 = 0.0

    for (x, y, w, h) in faces:
        roi_gray = gray[y:y + h, x:x + w]
        #roi_color = image[y:y + h, x:x + w]
        #eyes = eye_cascade.detectMultiScale(roi_gray, scaleFactor=3, minNeighbors=5, minSize=(30, 30),
        #                                    flags=cv2.cv.CV_HAAR_SCALE_IMAGE)
        #for (ex, ey, ew, eh) in eyes:
            #if (ey < w / 2):
                #cv2.rectangle(roi_color, (ex, ey), (ex + ew, ey + eh), (0, 0, 255), 2)

        # print "nose:" + str(nose)
        nose = nose_cascade.detectMultiScale(roi_gray, scaleFactor=1.1, minNeighbors=5, minSize=(30, 30),
                                             flags=cv2.cv.CV_HAAR_SCALE_IMAGE)
        for (np, nq, nr, ns) in nose:
            # if (nr < w / 3 and ns < h / 3):
            if (nq > w / 2.4 and nq < w / 1.6):
                x1 = nq

        # print "mouth:" + str(mouth)
        mouth = mouth_cascade.detectMultiScale(roi_gray, scaleFactor=1.1, minNeighbors=5, minSize=(30, 30),
                                               flags=cv2.cv.CV_HAAR_SCALE_IMAGE)
        for (mp, mq, mr, ms) in mouth:
            if (mq > h / 1.65):
                x2 = mq

        doitPasse = True

        if(x1 == 0 or x2 == 0) :
            doitPasse == False

        rep = (x2 - x1)
        floW = float(w)
        floRep = float(rep)
        proportion = floRep / floW

        return proportion

    return -1

def test_image_and_label(image, recognizer):
    image_untouched = image
    image_cv = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)
    image_np = np.array(image_cv, 'uint8')

    faces = faceCascade.detectMultiScale(
        image_np,
        scaleFactor=1.1,
        minNeighbors=5,
        flags = cv2.CASCADE_SCALE_IMAGE,
        minSize=(64, 64)
    )

    for (x, y, w, h) in faces:
        if h > 150 and w > 150:
            image_Face = cv2.resize(image_np[y: y + h, x: x + w], (400, 400))
            image = np.array(image_Face, 'uint8')
            nbr_predicted, conf = recognizer.predict(image)
            if conf < 150:
                if nbr_predicted >= 0 and nbr_predicted <= 7:
                    cv2.putText(image,"Francois", (5,20), cv2.FONT_HERSHEY_SIMPLEX, 1, 255)
                    print "Ce visage est celui de francois a un taux d'erreur de {} % et correspond a limage {}".format(conf, nbr_predicted)
                else:
                    cv2.putText(image,"Benny", (5,20), cv2.FONT_HERSHEY_SIMPLEX, 1, 255)
                    print "Ce visage est celui de Benny a un taux d'erreur de {} % et correspond a limage {}".format(conf, nbr_predicted)

            else:
                proportion = getPersonByProportion(image_untouched)
                if (proportion < 0.24295 and proportion != -1):
                    cv2.putText(image,"Francois", (5,20), cv2.FONT_HERSHEY_SIMPLEX, 1, 255)
                elif (proportion > 0.24295 and proportion != -1):
                    cv2.putText(image,"Benny", (5,20), cv2.FONT_HERSHEY_SIMPLEX, 1, 255)

            cv2.imshow("Recognizing Face", image)

    return images, labels

cascadePath = "haarcascade_frontalface_alt.xml"
path = '../Photo'

faceCascade = cv2.CascadeClassifier(cascadePath)
faceCascadeDefault = cv2.CascadeClassifier('haarcascade_frontalface_default.xml')
eye_cascade = cv2.CascadeClassifier('haarcascade_eye.xml')
nose_cascade = cv2.CascadeClassifier('haarcascade_mcs_nose.xml')
mouth_cascade = cv2.CascadeClassifier('haarcascade_mcs_mouth.xml')

recognizer = cv2.createLBPHFaceRecognizer()

images, labels = get_images_and_labels(path)
cv2.destroyAllWindows()

recognizer.train(images, np.array(labels))

cap = cv2.VideoCapture(0)
#cap = cv2.VideoCapture('../Video/REC1.AVI') #Pour lire des videos

while(cap.isOpened()):
    ret, frame = cap.read()

    if frame is not None:
        test_image_and_label(frame, recognizer)
        cv2.imshow("Image du feed", frame)

    else:
        cap.release()

    if cv2.waitKey(1) & 0xFF == ord('q'):
        cap.release()
        break

cv2.destroyAllWindows()

